/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20230628 (64-bit version)
 * Copyright (c) 2000 - 2023 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt10.dat, Thu Jan 11 06:03:48 2024
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001423 (5155)
 *     Revision         0x02
 *     Checksum         0x37
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "84F8    "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x20160527 (538314023)
 */
DefinitionBlock ("", "SSDT", 2, "HPQOEM", "84F8    ", 0x00001000)
{
    External (_SB_.DTS1, UnknownObj)
    External (_SB_.DTS2, UnknownObj)
    External (_SB_.DTS3, UnknownObj)
    External (_SB_.DTS4, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.ECMD, MethodObj)    // 3 Arguments
    External (_SB_.PCI0.LPCB.EC0_.ECOK, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.RPIO, MethodObj)    // 2 Arguments
    External (_SB_.PCI0.LPCB.EC0_.WPIO, MethodObj)    // 3 Arguments
    External (_SB_.PDTS, UnknownObj)
    External (_TZ_.TZ01._TMP, UnknownObj)
    External (PAMT, UnknownObj)
    External (TSDB, UnknownObj)

    Scope (\_SB)
    {
        Device (PTID)
        {
            Name (_HID, EisaId ("INT340E") /* Motherboard Resources */)  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0C02") /* PNP Motherboard Resources */)  // _CID: Compatible ID
            Name (IVER, 0x00030000)
            Name (_STA, 0x0F)  // _STA: Status
            Method (TSDL, 0, NotSerialized)
            {
                Return (TSD1) /* \_SB_.PTID.TSD1 */
            }

            Name (TSD1, Package (0x28)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "DIMM0_hotspot_U4C1", 
                0x03, 
                "DIMM1_hotspot_Q4D1", 
                0x03, 
                "IMVP_conn_Q7C1", 
                0x03, 
                "board_hotspot1_U3G3", 
                0x03, 
                "board_hotspot2_Q3G1", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP", 
                0x03, 
                "SDRAM_hotspot_RT5B1", 
                0x03, 
                "NGFF_slot_RT6G1", 
                0x03, 
                "IMVP_conn_RT7D1", 
                0x03, 
                "board_hotspot3_RT8F1"
            })
            Name (TSD2, Package (0x26)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "A-Skin Hotspot U21", 
                0x03, 
                "A-Skin Hotspot U21 IR", 
                0x03, 
                "B-Skin Hotspot U1", 
                0x03, 
                "B-Skin Hotspot U1 IR", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TZ00 _TMP", 
                0x03, 
                "SoC VR Thermsitor RT11", 
                0x03, 
                "Memory Thermistor RT9", 
                0x03, 
                "GNSS Board Ambient Thermistor R4", 
                0x03, 
                "System VR Thermistor RT10", 
                0x03, 
                "A-Skin MipiCam Thermistor RT8"
            })
            Name (PSDL, Package (0x26)
            {
                0x0B, 
                "Platform Power (mW)", 
                0x0B, 
                "Brick Power cW(100ths)", 
                0x0B, 
                "Battery Discharge Power cW(100ths)", 
                0x0B, 
                "Platform Average Power (mW)", 
                0x0B, 
                "Brick Average Power cW(0.01)", 
                0x0B, 
                "Battery Discharge Average Power cW(0.01)", 
                0x0C, 
                "Battery 1 Design Capacity (mWh)", 
                0x0C, 
                "Battery 1 Remaining Capacity (mWh)", 
                0x0C, 
                "Battery 1 Full Charge Capacity (mWh)", 
                0x0C, 
                "Battery 1 Full Resolution Voltage (mV)", 
                0x0C, 
                "Battery 1 Full Resolution Discharge Current (mA)", 
                0x0C, 
                "Battery 1 Full Resolution Charge Current (mA)", 
                0x0C, 
                "Battery 2 Remaining Capacity (mWh)", 
                0x0C, 
                "Battery 2 Full Charge Capacity (mWh)", 
                0x0C, 
                "Battery 2 Full Resolution Voltage (mV)", 
                0x0C, 
                "Battery 2 Full Resolution Discharge Current (mA)", 
                0x0C, 
                "Battery 2 Full Resolution Charge Current (mA)", 
                0x0C, 
                "Battery Pack 1 maximum power (mW)", 
                0x0C, 
                "Battery Pack 2 maximum power (mW)"
            })
            Method (OSDL, 0, NotSerialized)
            {
                Return (OSD1) /* \_SB_.PTID.OSD1 */
            }

            Name (OSD1, Package (0x15)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 1 ", 
                "RAW", 
                0x03, 
                "Thermistor 2 ", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW"
            })
            Name (OSD2, Package (0x18)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 1 ", 
                "RAW", 
                0x03, 
                "Thermistor 2 ", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW", 
                0x03, 
                "Thermistor 5 ", 
                "RAW"
            })
            Method (TSDD, 0, Serialized)
            {
                Name (TMPV, Package (0x14)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                TMPV [Zero] = ((\_SB.DTS1 * 0x0A) + 0x0AAC)
                TMPV [One] = ((\_SB.DTS2 * 0x0A) + 0x0AAC)
                TMPV [0x02] = ((\_SB.DTS3 * 0x0A) + 0x0AAC)
                TMPV [0x03] = ((\_SB.DTS4 * 0x0A) + 0x0AAC)
                TMPV [0x04] = ((\_SB.PDTS * 0x0A) + 0x0AAC)
                TMPV [0x0F] = \_TZ.TZ01._TMP /* External reference */
                Return (TMPV) /* \_SB_.PTID.TSDD.TMPV */
            }

            Method (PSDD, 0, Serialized)
            {
                Name (PWRV, Package (0x13)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                Return (PWRV) /* \_SB_.PTID.PSDD.PWRV */
            }

            Method (OSDD, 0, Serialized)
            {
                Return (Package (0x00){})
            }

            Method (SDSP, 0, NotSerialized)
            {
                Return (0x0A)
            }

            Name (PADA, Package (0x0A)
            {
                One, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0x1A, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF
            })
            Name (PADD, Package (0x0A)
            {
                0x02, 
                0x06A4, 
                0x06A0, 
                0x1A, 
                0x62, 
                0x63, 
                0x60, 
                0x61, 
                0x65, 
                0x64
            })
            Method (PADT, 0, NotSerialized)
            {
                If (PAMT)
                {
                    Return (PADA) /* \_SB_.PTID.PADA */
                }

                Return (PADD) /* \_SB_.PTID.PADD */
            }

            Method (RPMD, 0, Serialized)
            {
                Name (MTMP, Buffer (0x1A){})
                If ((\_SB.PCI0.LPCB.EC0.ECOK == One))
                {
                    MTMP [Zero] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x06)
                    MTMP [One] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x07)
                    MTMP [0x02] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x08)
                    MTMP [0x03] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x09)
                    MTMP [0x04] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x0A)
                    MTMP [0x05] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x0B)
                    MTMP [0x06] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x0C)
                    MTMP [0x07] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x0D)
                    MTMP [0x08] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x0E)
                    MTMP [0x09] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x0F)
                    MTMP [0x0A] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x10)
                    MTMP [0x0B] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x11)
                    MTMP [0x0C] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x12)
                    MTMP [0x0D] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x13)
                    MTMP [0x0E] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x14)
                    MTMP [0x0F] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x15)
                    MTMP [0x10] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x16)
                    MTMP [0x11] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x17)
                    MTMP [0x12] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x18)
                    MTMP [0x13] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x19)
                    MTMP [0x14] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x1A)
                    MTMP [0x15] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x1B)
                    MTMP [0x16] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x1C)
                    MTMP [0x17] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x1D)
                    MTMP [0x18] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x1E)
                    MTMP [0x19] = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x1F)
                }

                Return (MTMP) /* \_SB_.PTID.RPMD.MTMP */
            }

            Method (WPMD, 1, NotSerialized)
            {
                If ((SizeOf (Arg0) != 0x1A))
                {
                    Return (0xFFFFFFFF)
                }

                If ((\_SB.PCI0.LPCB.EC0.ECOK == One))
                {
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x06, DerefOf (Arg0 [Zero]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x07, DerefOf (Arg0 [One]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x08, DerefOf (Arg0 [0x02]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x09, DerefOf (Arg0 [0x03]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x0A, DerefOf (Arg0 [0x04]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x0B, DerefOf (Arg0 [0x05]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x0C, DerefOf (Arg0 [0x06]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x0D, DerefOf (Arg0 [0x07]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x0E, DerefOf (Arg0 [0x08]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x0F, DerefOf (Arg0 [0x09]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x10, DerefOf (Arg0 [0x0A]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x11, DerefOf (Arg0 [0x0B]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x12, DerefOf (Arg0 [0x0C]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x13, DerefOf (Arg0 [0x0D]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x14, DerefOf (Arg0 [0x0E]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x15, DerefOf (Arg0 [0x0F]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x16, DerefOf (Arg0 [0x10]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x17, DerefOf (Arg0 [0x11]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x18, DerefOf (Arg0 [0x12]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x19, DerefOf (Arg0 [0x13]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x1A, DerefOf (Arg0 [0x14]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x1B, DerefOf (Arg0 [0x15]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x1C, DerefOf (Arg0 [0x16]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x1D, DerefOf (Arg0 [0x17]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x1E, DerefOf (Arg0 [0x18]))
                    \_SB.PCI0.LPCB.EC0.WPIO (0xFB, 0x1F, DerefOf (Arg0 [0x19]))
                    \_SB.PCI0.LPCB.EC0.ECMD (0xFF, 0x10, 0x62)
                }

                Return (Zero)
            }

            Method (ISPC, 0, NotSerialized)
            {
                If ((\_SB.PCI0.LPCB.EC0.ECOK == One))
                {
                    \_SB.PCI0.LPCB.EC0.ECMD (0xFF, 0x10, 0x60)
                }

                Return (Zero)
            }

            Method (ENPC, 0, NotSerialized)
            {
                If ((\_SB.PCI0.LPCB.EC0.ECOK == One))
                {
                    \_SB.PCI0.LPCB.EC0.ECMD (0xFF, 0x10, 0x61)
                }

                Return (Zero)
            }

            Method (RPCS, 0, NotSerialized)
            {
                If ((\_SB.PCI0.LPCB.EC0.ECOK == One))
                {
                    Local0 = \_SB.PCI0.LPCB.EC0.RPIO (0xFF, 0x10)
                }

                Return (Local0)
            }

            Method (RPEC, 0, NotSerialized)
            {
                Local0 = Zero
                If ((\_SB.PCI0.LPCB.EC0.ECOK == One))
                {
                    Local1 = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x02)
                    Local0 |= Local1
                    Local1 = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x03)
                    Local0 |= (Local1 << 0x08)
                    Local1 = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x04)
                    Local0 |= (Local1 << 0x10)
                    Local1 = \_SB.PCI0.LPCB.EC0.RPIO (0xFB, 0x05)
                    Local0 |= (Local1 << 0x18)
                }

                Return (Local0)
            }
        }
    }
}

